# import os
from jnpr.junos import Device

from lxml import etree


def _rpc(hostname, ssh):
    dev = Device(
        host=hostname,
        user=ssh['username'],
        ssh_private_key_file=ssh['private-key'])
    dev.open()
    return dev.rpc


def load_config(hostname, ssh_params):
    # data = dev.rpc.get_config(options={'format': 'json'})
    return _rpc(hostname, ssh_params).get_config()


def load_interfaces(hostname, ssh_params):
    data = load_config(hostname, ssh_params)

    # print(etree.tostring(data, encoding='unicode'))

    def _ifc_info(e):
        name = e.find('name')
        assert name is not None, "expected interface 'name' child element"
        description = e.find('description')
        return {
            'name': name.text,
            'description': description.text if description is not None else None
        }

    # for i in data.xpath('//configuration/groups/interfaces/interface'):
    for i in data.xpath('//configuration/interfaces/interface'):
        info = _ifc_info(i)
        yield info
        # ifc_name = i.xpath('./name/text()')
        # assert ifc_name
        # print(ifc_name[0])
        for u in i.xpath('./unit'):
            unit_info = _ifc_info(u)
            unit_info['name'] = "%s.%s" % (info['name'], unit_info['name'])
            yield unit_info
            # print("%s.%s" % (ifc_name[0], u))
    #
    # print("-----routing-instances-----")
    # for i in data.xpath("//configuration/routing-instances/instance/interface"):
    #     print(i.xpath('./name/text()'))

